<?php

/*
logger_mve

by Marph SQ3MVE
sq3mve@marph.pl

znaków: UTF-8
*/

class loggerMPH
{
	private $plik_log = 'log.adi';
	private $tryb_szukania = 'dokladny';
	private $tryb_prezentacji = 'tabela';
	private $tab_emisje = array();
	private $tab_pasma = array();
	private $tab_wynik_log = array();
	
	public function __construct($p_conf)
	{
		if(file_exists($p_conf))
		{
			$plik_conf = fopen($p_conf, 'r');
			while(!feof($plik_conf))
			{
				$linia_conf = fgets($plik_conf, 1024);
				if(strlen($linia_conf) > 2 and substr($linia_conf, 0, 1) <> '#' and substr($linia_conf, 0, 1) == '[')
				{
					$parametr = trim(substr($linia_conf, 0, strpos($linia_conf, '=')));
					$wynik = trim(substr($linia_conf, strpos($linia_conf, '=') + 1));
					switch($parametr)
					{
						case '[plik_adif]':
							$this->plik_log = $wynik;
							break;
						case '[tryb_prezentacji]':
							$this->tryb_prezentacji = $wynik;
							break;
						case '[tryb_szukania]':
							$this->tryb_szukania = $wynik;
							break;
						case '[pasmo]':
							$this->tab_pasma[] = $wynik;
							break;
						case '[emisja]':
							$this->tab_emisje[] = $wynik;
							break;
					}
				}
			}
			fclose($plik_conf);
		}
		else
		{
			$this->tab_pasma[0] = '80M';
			$this->tab_pasma[1] = '40M';
			$this->tab_pasma[2] = '20M';
			$this->tab_pasma[3] = '10M';
			$this->tab_pasma[4] = '2M';
			$this->tab_pasma[5] = '70CM';
			
			$this->tab_emisje[0] = 'CW';
			$this->tab_emisje[1] = 'SSB';
			$this->tab_emisje[2] = 'FM';
		}
		
	}
	
	private function przelicz_freq_band($freq)
	{
		$freq = substr($freq, 0, strpos($freq, "."));
		$band = '???';
		
		if($frq > 1 and $freq < 2)
		{
			$band = '180M';
		}                 
		elseif($freq > 3 and $freq < 4)
		{                 
			$band = '80M';
		}                 
		elseif($freq > 7 and $freq < 8)
		{                 
			$band = '40M';
		}                 
		elseif($freq > 10 and $freq < 11)
		{                 
			$band = '30M';
		}                 
		elseif($freq > 14 and $freq < 15)
		{                 
			$band = '20M';
		}                 
		elseif($freq > 15 and $freq < 20)
		{                 
			$band = '17M';
		}                 
		elseif($freq > 20 and $freq < 22)
		{                 
			$band = '15M';
		}                 
		elseif($freq > 22 and $freq < 25)
		{                 
			$band = '12M';
		}                 
		elseif($freq > 29 and $freq < 30)
		{                 
			$band = '10M';
		}                 
		elseif($freq > 50 and $freq < 53)
		{                 
			$band = '6M';
		}                 
		elseif($freq > 140 and $freq < 150)
		{                 
			$band = '2M';
		}
		elseif($freq > 400 and $freq < 450)
		{
			$band = '70CM';
		}                  
		elseif($freq > 1000 and $freq < 1400)
		{                  
			$band = '23CM';
		}
		
		return $band;
	}
	
	private function zeruj_tabele_wynikow()
	{
		foreach($this->tab_pasma as $pasmo)
		{
			foreach($this->tab_emisje as $emisja)
			{
				$this->tab_wynik_log[$pasmo][$emisja] = 0;
			}
		}
		
		return $this->tab_wynik_log;                                                                                     
	}

	private function otworz_i_znajdz($znak)
	{
		$tab_zrodlo = array();
		$tab_wynik = array();
		$nr_w = 0;
		$czy_band = true;
		$linia = '';
		if($this->tryb_szukania == 'dokladny')
		{
			$call_znak = '>' . strtoupper($znak) . '<';
		}
		else
		{
			$call_znak = '>' . strtoupper($znak);
		}
		
		if(file_exists($this->plik_log))
		{
			$p_log = fopen($this->plik_log, 'r');
			while(!feof($p_log))
			{
				$linia .= fgets($p_log, 1024);
				
				if(strpos($linia, 'EOH') > 0)
				{
					$linia = '';
				}
				
				if(strpos($linia, 'EOR') > 0)
				{
					$linia = substr($linia, 0, -6);
					$linia = str_replace(" ", "", $linia);
					if(strpos($linia, $call_znak) > 0)
					{
						if(strpos($linia, '<BAND') > 0)
						{
							$czy_band = true;
						}
						else
						{
							$czy_band = false;
						}
							
						$tab_linia = strtr($linia, "<>", ";;");
						$tab_zrodlo = explode(";", $tab_linia);
						$i = 0;
						foreach($tab_zrodlo as $wynik)
						{
							if($i > 0)
							{
								if(fmod($i, 2) == 0)
								{ 
									#echo '[' . $nr_w . '][' . $klucz . '] = ' . $wynik . ' <br />' . "\n";
									$tab_wynik[$nr_w][$klucz] = trim($wynik);
								}
								else
								{
									$klucz = substr($wynik, 0, strpos($wynik, ":"));
								}
							}
							$i++;
						}
						if(!$czy_band)
						{
							$tab_wynik[$nr_w]['BAND'] = $this->przelicz_freq_band($tab_wynik[$nr_w]['FREQ']);
						}
						$nr_w++;
					}
					$linia = '';
				}
			}
			fclose($p_log);
		}
		return $tab_wynik;
	}

	private function generuj_tabele_wynikow($tab_zrodlo)
	{
		
		foreach($tab_zrodlo as $tz)
		{
			$this->tab_wynik_log[$tz['BAND']][$tz['MODE']]++;
		}
		
		return $this->tab_wynik_log;
	}
	
	private function pokaz_czas_plik()
	{
		if(file_exists($this->plik_log))
		{
			return date ("Y-m-d H:i:s", filemtime($this->plik_log));
		}
	}

	public function wyswietl_wynik($znak)
	{
		$this->zeruj_tabele_wynikow();
		
		$tab_zrodlo = $this->otworz_i_znajdz($znak);
		
		$this->tab_wynik_log = $this->generuj_tabele_wynikow($tab_zrodlo);
		
		echo '<p id="p_logger_mve">Uzyskany wynik dla znaku <b>' . strtoupper($znak) . '</b> (dane na dzień ' . $this->pokaz_czas_plik() . ') : </p>' .  "\n";
		
		if($this->tryb_prezentacji == 'lista')
		{
			echo '<table id="table_logger_mve">' . "\n";
			echo '	<tr>' . "\n";
			echo '		<th>Lp.</th><th>Pasmo</th><th>Modulacja</th><th>Liczba QSO</th>' . "\n";
			echo '	</tr>' . "\n";
			$lp = 1;
			foreach($this->tab_wynik_log as $pasmo => $t_e)
			{
				foreach($t_e as $emisja => $wynik)
				{
					if($wynik > 0)
					{
						echo '	<tr>' . "\n";
						echo '		<td>' . $lp . '</td><td>' . $pasmo . '</td><td>' . $emisja . '</td><td>' . $wynik . '</td>' . "\n";
						echo '	</tr>' . "\n";
						$lp++;
					}
				}
			}
			echo '</table>' . "\n";
		}
		elseif($this->tryb_prezentacji == 'tabela')
		{
			$wiersz_naglowek = '';
			$lp = 1;
			echo '<table id="table_logger_mve">' . "\n";
			foreach($this->tab_wynik_log as $pasmo => $t_e)
			{
				$wiersz = '';
				foreach($t_e as $emisja => $wynik)
				{ 
					if($lp == 1)
					{
						$wiersz_naglowek .= '		<th>' . $emisja . '</th>' . "\n";
					}
					if($wynik > 0)
					{
						$klasa_trafiony = 'class="trafiony_logger_mve"';
					}
					else
					{
						$klasa_trafiony = '';
					}
					$wiersz .= '		<td ' . $klasa_trafiony . '>' . $wynik . '</td>' . "\n";
				}
				if($lp == 1)
				{
					echo '	<tr>' . "\n";
					echo '		<th></th>' . "\n";
					echo $wiersz_naglowek;
					echo '	</tr>' . "\n";
				}
				echo '	<tr>' . "\n";
				echo '		<th>' . $pasmo . '</th>' . "\n" . $wiersz . "\n";
				echo '	</tr>' . "\n";
				$lp++;
			}
			echo '</table>' . "\n";
		}
		else
		{
			echo '<p>bubel :-((</p>' . "\n";
		}
	}
}

?>
